Description: Bonjour,
J'utilise pythontex pour générer des QCM a valeurs aléatoires et bénéficier des outils avancés de calcul
numérique et formel de numpy et sympy.
Afin de faciliter la conception de qcm, j'ai développé une fonction python qui génere les macros latex de
proposition de réponses tout en vérifiant I'unicité des propositions.
Le probleme est que l'ordre de génération des commandes pythontex différe de 'ordre dans lequel les
réponses sont mises en page pour les questions n’utilisant pas cette fonction python.
Je joins un modéle de gcm permettant de reproduire le bug (voir le 2e exemplaire généré).
J'ai trouvé une astuce pour contourner le probléme: re-initialiser la graine aléatoire de AMC a chaque
environnement 'question’. Je joins également un patch.
Y a-t-il une incompatibilité d'usage entre AMC et mon utilisation de pythontex ? Peut-étre qu'une solution plus
élégante pourrait s'appliquer.
En tout cas, merci pour cet outil !

History

10/08/2023 03:20 pm - Frédéric Bréal
Je ne suis pas sir de comprendre pas votre question. Je ne maitrise pas python et pythontex.

> Le probléme est que l'ordre de génération des commandes pythontex differe de I'ordre dans lequel les réponses sont mises en page pour les

questions n’utilisant pas cette fonction python

AMC mélange les réponses donc pour toujours garder le méme ordre, il faut écrire

<pre>

\usepackage[francais,bloc,completemulti,ordre]{automultiplechoice}

</pre>

ou

<pre>

\begin{reponseshoriz}[o

\bonne{$0\legslant x2 < \py{latex(b*b)}$}
\mauvaise{$\py{latex(a*a)}<x"2<\py{latex(b*b)}$}

\mauvaise{$0\legslant x*2 < \py{latex(a*b)}$}

\end{reponseshoriz}

</pre>

Je n'ai pas utiliser votre patch.

10/08/2023 03:22 pm - Frédéric Bréal
Frédéric Bréal wished to write:

> Je n'ai pas utilisé votre patch.
10/09/2023 10:06 am - Jean-Matthieu Etancelin
Merci pour votre réponse.

L'utilisation de pythontex avec AMC implique une compilation (latex dans mon cas) supplémentaire, le filtre, afin de construire un fichier tex qui est

injecté dans le fichier source. L'ordre des propositions de réponse n'est pas identique entre la compilation de pré-processeur et les compilations

usuelles d'AMC.
Je souhaite conserver un mélange systématique des propositions de réponse.

Est-il possible de fixer (ou transférer) les paramétrages utilisés dans les compilations usuelles d'’AMC garantissant un ordre donné d'une compilation a

l'autre (sujet, calage, bareme, ...) également a |'étape de pré-processing ?

06/13/2025 10:23 am - Alexis Bienveniie
- Status changed from New to Closed

- % Done changed from 0 to 100

Deux exemples de configuration permettant I'utilisation de pythontex:

* avec un script ad-hoc : https://alexis-bienvenue-ext.forge.apps.education.fr/modeles-amc/#/template/pythontex

* avec latexmk : https://alexis-bienvenue-ext.forge.apps.education.fr/modeles-amc/#/template/pythontex-latexmk

Files

AMC_pythontex_bug-sujet.pdf 116.3 kB 09/19/2023 Jean-Matthieu Etancelin
pythontex-amc.patch 431 Bytes 09/19/2023 Jean-Matthieu Etancelin
bugPythonTex.tgz 2.7kB 09/19/2023 Jean-Matthieu Etancelin
